#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <ctype.h>
#include <string.h>
#include <sys/stat.h>
#define NAMELEN 61
typedef struct
{
    char name[NAMELEN];
    float average;
} StudentT;

typedef union
{
    StudentT stud;
    char st[sizeof(StudentT)];
} BufferT;

typedef struct
{
    int nb;
    float average;
} ElementT;

typedef enum {FALSE, TRUE} BooleanT;

void sort(const char filename[], const char sorted_filename[])
{
    ElementT el, t[100];
    char msgBuf[201];
    int i, j, n, fd1, fd2;
    BooleanT flag;
    BufferT stu;
    /* read file to array t */
    j = 0;
    fd1 = open(filename, O_RDONLY);
    while ( read(fd1, stu.st, sizeof(BufferT)) > 0 && j < 100)
    {
        t[j].nb = j;
        t[j].average = stu.stud.average;
        j++;
    }
    n = j;
    /* sort array t by average */
    j = 0;
    do
    {
        flag = TRUE;
        for (i = 1; i < n - j ; i++)
            if (t[i-1].average < t[i].average)
            {
                memcpy(&el, &t[i-1], sizeof(ElementT));
                memcpy(&t[i-1], &t[i], sizeof(ElementT));
                memcpy(&t[i], &el, sizeof(ElementT));
                flag = FALSE;
            }
    }
    while (flag == FALSE);
    /* write sorted output */
    if ((fd2 = open(sorted_filename, O_CREAT | O_WRONLY | O_TRUNC, S_IREAD | S_IWRITE)) < 0)
    {
        sprintf(msgBuf, "\nCannot create %s. ", sorted_filename);
        perror(msgBuf);
        getchar();
        exit(1);
    }
    for (i = 0; i < n; i++)
    {
        lseek(fd1, (long)(t[i].nb *sizeof(BufferT)), SEEK_SET);
        read(fd1, stu.st, sizeof(BufferT));
        write(fd2, stu.st, sizeof(BufferT));
    }
    close(fd1);
    close(fd2);
}

void show_students(char filename[])
{
    BufferT stu;
    char s[41];
    int j, fd1;

    if ((fd1 = open(filename, O_RDONLY)) < 0)
    {
        sprintf(s, "Cannot open %s for reading. ", filename);
        perror(s);
        getchar();
        exit(3);
    }

    memset(&stu, '\0', sizeof(BufferT));
    j = 0;
    while ( read(fd1, stu.st, sizeof(BufferT)) > 0)
    {
        printf("\n%d. %-60s %7.2f", j++, stu.stud.name, stu.stud.average);
        memset(&stu, '\0', sizeof(BufferT));
    }
    close(fd1);
}
/*
  readStudents
		reads student data from stdin
  Params:
		fd1 = jandle for file to write
  Returns:
		-
  Changes:
		file to write
*/
void readStudents(int fd1, int n)
{
    BufferT stu;
    int i;
    for (i = 1; i <= n; i++)
    {
        memset(stu.st, '\0', sizeof(BufferT));
        printf("Name: ");
        scanf("%s", stu.stud.name);
        printf("average: ");
        scanf("%f%*c", &stu.stud.average);
        if (write(fd1, stu.st, sizeof(BufferT)) < sizeof(BufferT))
        {
            perror("Short write. ");
            getchar();
            exit(5);
        }
    }
}
/*
  updateStudents
		update student records
  Params:
		fd1 = handle for file to update
  Returns:
		-
  Changes:
		file to update
*/
void updateStudents(const char *filename, int n)
{
    char ch;
    BufferT stu;
    char nameAux[NAMELEN];
    float avgAux;
    int fd1, i;
    long l;

    ch=getchar();
    fd1 = open(filename, O_RDWR);

    while ( toupper(ch) == 'Y')
    {
        printf("\nStudent number= ");
        scanf("%d%*c", &i);
        l = lseek(fd1, (long)(i * sizeof(BufferT)), SEEK_SET);
        printf("\toffset=%ld for i=%d\n", l, i);
        read(fd1, stu.st, sizeof(BufferT));
        printf("Current name is: %s\nNew name: ", stu.stud.name);
        scanf("%s", nameAux);
        if (*nameAux) strcpy(stu.stud.name, nameAux);
        printf("Current average is: %f\nNew average: ", stu.stud.average);
        scanf("%f", &avgAux);
        if (avgAux > 0) stu.stud.average = avgAux;
        l = lseek(fd1, (long)(i * sizeof(BufferT)), SEEK_SET);
        printf("\toffset=%ld for i=%d\n", l, i);
        write(fd1, stu.st, sizeof(BufferT));
        printf("\nUpdate more student info [Yes=Y/y, No=other char]? ");
        scanf("%*c%c", &ch);
    }
    close(fd1);
}

int main(int argc, char *argv[])
{
    unsigned int n;
    int fd1;
    char filename[] = "Group.dat";
    char sorted_filename[] = "SortedGroup.dat";

    printf("\nNumber of students in the group= ");
    scanf("%u%*c", &n);
    /* create group file */
    if ((fd1 = open(filename, O_CREAT | O_WRONLY | O_TRUNC, S_IREAD | S_IWRITE)) < 0)
    {
        perror("\nCannot create Group.dat. ");
        getchar();
        exit(1);
    }
    /* student data input */
    readStudents(fd1, n);
    close(fd1);
    printf("\nGroup.dat contents after creation\n");
    show_students(filename);
    /* add new records to file */
    printf("\nNumber of students to add to group= ");
    scanf("%u%*c", &n);
    if ((fd1 = open(filename, O_RDWR)) < 0)
    {
        perror("\nCannot append to Group.dat. ");
        getchar();
        exit(1);
    }
    if (lseek(fd1, 0L, SEEK_END) < 0)
    {
        perror("\nlseek to end failed. ");
        getchar();
        exit(4);
    }
    /* student data input */
    readStudents(fd1, n);
    close(fd1);
    printf("\nGroup.dat contents after addition\n");
    show_students(filename);
    printf("\nUpdate student info [Yes=Y/y, No=other char]? ");
    updateStudents(filename, n);
    printf("\nGroup.dat contents after changes\n");
    show_students(filename);
    getchar();
    sort(filename, sorted_filename);
    printf("\nGroup sorted by average\n");
    show_students(sorted_filename);
    getchar();
    return 0;
}
